<?php
/*
 * jumi_PV_SystemApp.php:
 * Web Application to visualize statistics of a photo voltaic system
 *
 * @author Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 * @copyright Copyright (C) 2012 Joachim Schmidt. All rights reserved.
 * @license	 GNU/GPL
 *
 */

use phpRGraph\rgraph_chart;
use phpRGraph\rgraph_options;

$report_type = array ();
$monat = array ();
$text = array ();

$parms = array();
require_once 'pv_system_settings.php';

$jos = $parms ['table_prefix'];
$start_year = $parms ['start_year'];

if (array_key_exists ( 'lang', $_GET ))
	$language = $_GET ['lang'];
else
	$language = "en";

$urlbase = $parms ['urlbase'];
$basepath = $_SERVER["DOCUMENT_ROOT"];

$language_ini = "PV_SystemAppText-" . $language . ".ini";
$text = parse_ini_file ( $language_ini, true );

include $basepath . $parms ['lib'];

$db_config = $basepath . $parms ['dbconfig'];

$sql = "SELECT max(date) FROM " . $jos . "pv_senec_days";
$date_sql = rgraph_chart::getDataFromDB ($db_config, $sql);
$date_sql = $date_sql[0];

$sql = "SELECT min(date) FROM " . $jos . "pv_senec_days";
$start_date = rgraph_chart::getDataFromDB ($db_config, $sql);
$start_date = $start_date[0][0];

$sql = "SELECT YEAR( date ) FROM " . $jos . "pv_senec_year where Stromerzeugung > 0 GROUP BY YEAR( date )";
$years_sql = rgraph_chart::getDataFromDB ($db_config, $sql);
$years_sql = $years_sql[0];

$temp = explode ( "-", $date_sql[0] );
$year = $temp [0];
$mon = ltrim ( $temp [1], "0" );
$month = $text ['monat'] [$mon];
$day = ltrim ( $temp [2], "0" );

$html = "<!DOCTYPE html>
<html lang='" . $language . "'>
<head>";

$html .= "\n<script src='" . $urlbase . $parms ['pv_system_root'] . "/js/jquery.min.js'></script>";
$html .= "<script src='" . $urlbase . $parms ['rgraph_library'] . "RGraph.common.lib.js'></script>";
$html .= "\n<script src='" . $urlbase . $parms ['pv_system_root'] . "/js/pv_system.js'></script>";
$html .= "\n<link href='" .  $urlbase . $parms ['pv_system_root'] . "/css/pv_system.css' rel='stylesheet' type='text/css' />";
$html .= "\n<script  type='text/javascript' src='" . $urlbase . $parms ['pv_system_root'] . "/js/jquery_msgbox-min.js'></script>";

$html .= "\n</head>
\n<body>
<div style='width: 90%; padding-left: 30px;'>";


$url = $parms ['url'];
$err_txt = $text ['date_error'];
flush ();

$html .= "
     <h4>" . $text ['title'] . "</h4>
     <div style='font-size: 12px;' >" . $text ['introduction'] . $text ['title2'] . "\n</div>\n<div id='form'>
     \n<form name='pv_system_form' action='' style='display: inline; white-space: wrap;'>
     <br />
     &nbsp;<b style='font-size: 12px;white-space: wrap' display: inline;>" . $text ['month'] . ": </b><select name='fmonth' size='1' class='select'>
     <option selected='selected' value='$mon'>" . $month . "</option>";
for($i = 1; $i < 13; $i ++)
	$html .= "\n     <option value='$i'>" . $text ['monat'] [$i] . "</option>";

$html .= "</select>
     &nbsp;<b style='font-size: 12px;white-space: wrap'>" . $text ['year'] . ":  </b><select name='fyear' size='1' class='select'>
     <option selected='selected' value='$year'>$year</option>";
for($i = 0; $i < count ( $years_sql ); $i ++) {
	$html .= "\n     <option value='$years_sql[$i]'>$years_sql[$i]</option>";
}

$qq = '"';
$html .= "
     </select>
     <br /><br />
     &nbsp;<input type='radio' id='chart1' name='chart' value='1' checked='checked' onclick='jQuery($qq#report3$qq).show()'>
     <label style='font-size: 12px;white-space: wrap' display: inline;' for='chart1'>". $text ['type1'] . "</label>
     &nbsp;<input type='radio' id='chart2' name='chart' value='2' onclick='jQuery($qq#report3$qq).hide()'>
     <label style='font-size: 12px;white-space: wrap' display: inline;' for='chart2'>". $text ['type2'] . "</label>
     &nbsp;<input type='radio' id='chart3' name='chart' value='3' onclick='jQuery($qq#report3$qq).hide()'>
     <label style='font-size: 12px;white-space: wrap' display: inline;' for='chart3'>". $text ['type3'] . "</label>
     <br />
     <br />
             
    <div class='btn-group' role='group' style='white-space: nowrap'>
     &nbsp;<input name='report1' type='button' value='" . $text['report_type'] [1] . "' class='button' data-toggle='button' onclick='processResults(this.form,1)'/>
     &nbsp;<input name='report2' type='button' value='" . $text['report_type'] [2] . "' class='button' data-toggle='button' onclick='processResults(this.form,2)'/>
     &nbsp;<input id='report3' name='report3' type='button' value='" . $text['report_type'] [3] . "' class='button' data-toggle='button' onclick='processResults(this.form,3)'/>
    </div>
 </form>
   </div>";

$html .= "\n<script>
    // <![CDATA[
    function processResults (form, report) {
    
	   var type = jQuery('input[name=chart]:checked').val();
	   Item   = form.fmonth.selectedIndex;
	   var fmonth = form.fmonth.options[Item].value;
	   var month_name = form.fmonth.options[Item].text;
	   Item   = form.fyear.selectedIndex;
	   var fyear  = form.fyear.options[Item].value;

       var fday = '1';

	    if (report == '1' || report == '2' || report == '3')
        {
              var rc = checkDate(report, fday, fmonth, fyear, '$day', '$mon', '$year', '$start_date');
			  if (rc != false)
			  {
			    var cause =  +month_name +' ' +fyear;
		        
			    if (rc == 3 || rc == 5)
		         cause = month_name +' ' +fyear;
		        
		        alert_box('$err_txt', build_errormsg('$language', rc, cause));
			    return false;
			  }
        }

	   var url = '$url?request=html&lang=$language&report=' +report +'&type=' +type +'&fmonth=' +fmonth + '&fyear=' +fyear;
	   //alert (url);
     
        jQuery('#html_text' ).load( url, function() {
       });
	   
	   var url = '$url?request=chart&lang=$language&report=' +report +'&type=' +type +'&fmonth=' +fmonth + '&fyear=' +fyear;
	   jQuery('#chart').empty();
	   jQuery('#chart' ).load( url, function() {
       });
      
   }
   // ]]>
   </script> ";

$html .= "
<br />
<div id='my_charts'>
 <div id='chart' style='height:auto;'></div>
 <div id='html_text' class='htmlText' style='min-height:460px;'>" . $text ['author'] . "</div>
</div>";

echo $html;

?>
     
