/*
 * AjaxRequest used for PV-System Application (implements XMLHttpRequest)
 */
function getdojoHTTPObject() {
	
	var xhr = false;
	try {
	if (window.XMLHttpRequest) {
		xhr = new XMLHttpRequest();
		return xhr;
	}	
	} catch (e) {
       alert("error" + e);  
	}	
	return xhr;
}

function get_myData(url) {
	
	var request = getdojoHTTPObject();
	if (request) {
		request.onreadystatechange = function() {
			parsedojoResponse(request);
		};
		request.open("GET", url, true);
		request.send(null);
	}
}

function parsedojoResponse(request) {
	
	if (request.readyState == 4) {
		if (request.status == 200 || request.status == 304) {
			processdojoReceived(request.responseText);
		}
	}
}

function processdojoReceived(returnData) {

	if (returnData == null || returnData == undefined)
		alert("no data received");
	else {
		var dpos = returnData.indexOf('{');
		if (dpos != 0)			
		 var data = JSON.parse(returnData.substring(dpos));
		else		 		
		 var data = JSON.parse(returnData);
		
		if (data == null || data == undefined)
			alert("problem with" + returnData);

		var legend_element1 = document.getElementById('legend');
		var legend_element2 = document.getElementById('legend2');

		var div_element = document.getElementById(data.id);
		if (div_element == null) {
			alert("node (div) " + data.id + " not found");
		}

		switch (data.data_type) {
		
		case "chart_data":
			div_element.innerHTML = "";
			div_element.style.width = data.width;
			div_element.style.height = data.height;

			if (data.legend == undefined) {
				if (legend_element1 && legend_element1.innerHTML != "")
					legend_element1.style.marginTop = "-2000px";
				if (legend_element2 && legend_element2.innerHTML != "")
					legend_element2.style.marginTop = "-2000px";
			}

			if (data.legend != undefined) {
				if (data.legend.node == "legend") {
					legend_element1.style.margin = data.legend.margin;
					if (legend_element2.innerHTML != "")
						legend_element2.style.marginTop = "-2000px";
				} else {
					legend_element2.style.margin = data.legend.margin;
					if (legend_element1.innerHTML != "")
						legend_element1.style.marginTop = "-2000px";
				}
			}

			show_chart(data);
			break;

		case "html_data":
			div_element.innerHTML = "";
			var html_text = JSON.stringify(data.text);
			var strlen = html_text.length - 2;
			html_text = html_text.substr(1, strlen);
			div_element.innerHTML = html_text;
			// alert(html_text);
			break;

		case "error_data":
			  var error_title = JSON.stringify(data.error_title).replace(/['"]/g,'');
			  var error_msg   = JSON.stringify(data.error_msg).replace(/['"]/g,'');
			  alert_box( error_title, error_msg );
			break;

		default:
			alert("invalid data_type: " + data.data_type);
		}
	}
}

function checkDate(report, fday, fmonth, fyear, cday, cmonth, cyear, start_date) {

	var start = start_date.split("-");
	start[1] = parseInt(start[1]);
	start[2] = parseInt(start[2]);

	if (report != '1')
		fday = '1';
	var valid = new Date(cyear, cmonth - 1, cday);
	var inp = new Date(fyear, fmonth - 1, fday);
	var start = new Date(start[0], start[1] - 1, start[2]);

	if (report == '4') {

		switch (fmonth) {
		case '2':
			if (fday > 29)
				return 2;
			if (fyear % 4 != 0 && fday > 28)
				return 2;
			break;

		case '4':
		case '6':
		case '9':
		case '11':
			if (fday > 30)
				return 2;
		}

		if (inp.getTime() > valid.getTime())
			return 1;
		if (inp.getTime() < start.getTime())
			return 4;
	}

	if (report == '1' || report == '2') {
		if (inp.getMonth() > valid.getMonth() && fyear >= valid.getFullYear())
			return 3;
		if (inp.getMonth() < start.getMonth() && fyear <= start.getFullYear())
			return 5;
	}
	return false;
}

function alert_box (title, content)
{
	jQuery.msgBox({
        title: title,
        content: content,
        autoClose: true,
        timeOut: 10000,
       	opacity: 0.6	
    });	
}

function build_errormsg(language, reason, cause)
{
   if (language == "de")
    {
	   error_hint1="Das angeforderte Datum &quot;" +cause +"&quot; liegt in der Zukunft oder es gibt noch keine Daten f&uuml;r diesen Zeitraum.<br>&Uuml;berpr&uuml;fen / &auml;ndern sie die Datumseingabe.";
	   error_hint2="Das angeforderte Datum &quot;" +cause +"&quot; existiert nicht bzw. ist falsch. &Uuml;berpr&uuml;fen / &auml;ndern sie die Datumseingabe.</div>";
	   error_hint3="Das angeforderte Datum &quot;" +cause +"&quot; liegt <b>vor</b> der ersten Aktualisierung der Datenbank, deshalb sind daf&uuml;r keine Daten vorhanden.<br>&Uuml;berpr&uuml;fen / &auml;ndern sie die Datumseingabe.";
	}
   else
	{
	   error_hint1="Your requested date &quot;" +cause +"&quot; is in the future or there is yet no data for this time frame. Check and change your input.";
	   error_hint2="Your requested date &quot;" +cause +"&quot; does not exist or it is not valid.<br>Check and change your input.";
	   error_hint3="Your requested date &quot;" +cause +"&quot; is <b>before</b> first update of database.<br>Therefore there is no data available. Check and change your input.";
	}   
	
    switch (reason)
    {
		case 1:
		case 3:	
			return error_hint1;
			break;
		case 2:
			return error_hint2;
			break;
		default:
			return error_hint3; 
    }
   
	return "unknown cause";
}